Index: /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.Designer.cs
===================================================================
--- /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.Designer.cs	(revision 4700)
+++ /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.Designer.cs	(revision 4701)
@@ -26,5 +26,5 @@
       System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea1 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
       System.Windows.Forms.DataVisualization.Charting.Legend legend1 = new System.Windows.Forms.DataVisualization.Charting.Legend();
-      System.Windows.Forms.DataVisualization.Charting.Title title1 = new System.Windows.Forms.DataVisualization.Charting.Title();
+      System.Windows.Forms.DataVisualization.Charting.Title title1= new System.Windows.Forms.DataVisualization.Charting.Title();
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HeatmapView));
       this.chart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
@@ -32,6 +32,9 @@
       this.ZeroLabel = new System.Windows.Forms.Label();
       this.OneLabel = new System.Windows.Forms.Label();
+      this.GrayscalesPictureBox = new System.Windows.Forms.PictureBox();
+      this.grayscaledImagesCheckBox = new System.Windows.Forms.CheckBox();
       ((System.ComponentModel.ISupportInitialize)(this.chart)).BeginInit();
       ((System.ComponentModel.ISupportInitialize)(this.ColorsPictureBox)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.GrayscalesPictureBox)).BeginInit();
       this.SuspendLayout();
       // 
@@ -46,6 +49,4 @@
       chartArea1.AxisX.LabelAutoFitStyle = ((System.Windows.Forms.DataVisualization.Charting.LabelAutoFitStyles)((System.Windows.Forms.DataVisualization.Charting.LabelAutoFitStyles.IncreaseFont | System.Windows.Forms.DataVisualization.Charting.LabelAutoFitStyles.DecreaseFont)));
       chartArea1.AxisX.Title = "Solution Index";
-      chartArea1.AxisY.Maximum = 1D;
-      chartArea1.AxisY.Minimum = 0D;
       chartArea1.AxisY.Title = "Solution Index";
       chartArea1.CursorX.IsUserEnabled = true;
@@ -61,5 +62,5 @@
       this.chart.Location = new System.Drawing.Point(0, 0);
       this.chart.Name = "chart";
-      this.chart.Size = new System.Drawing.Size(403, 358);
+      this.chart.Size = new System.Drawing.Size(403, 335);
       this.chart.TabIndex = 0;
       this.chart.Text = "chart";
@@ -68,7 +69,4 @@
       title1.Text = "Solution Similarities";
       this.chart.Titles.Add(title1);
-      this.chart.CustomizeLegend += new System.EventHandler<System.Windows.Forms.DataVisualization.Charting.CustomizeLegendEventArgs>(this.chart_CustomizeLegend);
-      this.chart.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown);
-      this.chart.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove);
       // 
       // ColorsPictureBox
@@ -107,16 +105,45 @@
       this.OneLabel.Text = "1.0";
       // 
+      // GrayscalesPictureBox
+      // 
+      this.GrayscalesPictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.GrayscalesPictureBox.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
+      this.GrayscalesPictureBox.Image = ((System.Drawing.Image)(resources.GetObject("GrayscalesPictureBox.Image")));
+      this.GrayscalesPictureBox.Location = new System.Drawing.Point(409, 23);
+      this.GrayscalesPictureBox.Name = "GrayscalesPictureBox";
+      this.GrayscalesPictureBox.Size = new System.Drawing.Size(35, 312);
+      this.GrayscalesPictureBox.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
+      this.GrayscalesPictureBox.TabIndex = 15;
+      this.GrayscalesPictureBox.TabStop = false;
+      this.GrayscalesPictureBox.Visible = false;
+      // 
+      // grayscaledImagesCheckBox
+      // 
+      this.grayscaledImagesCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.grayscaledImagesCheckBox.AutoSize = true;
+      this.grayscaledImagesCheckBox.Location = new System.Drawing.Point(0, 338);
+      this.grayscaledImagesCheckBox.Name = "grayscaledImagesCheckBox";
+      this.grayscaledImagesCheckBox.Size = new System.Drawing.Size(115, 17);
+      this.grayscaledImagesCheckBox.TabIndex = 16;
+      this.grayscaledImagesCheckBox.Text = "Grayscaled images";
+      this.grayscaledImagesCheckBox.UseVisualStyleBackColor = true;
+      this.grayscaledImagesCheckBox.CheckedChanged += new System.EventHandler(this.grayscaledImagesCheckBox_CheckedChanged);
+      // 
       // HeatmapView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.grayscaledImagesCheckBox);
       this.Controls.Add(this.ZeroLabel);
       this.Controls.Add(this.OneLabel);
       this.Controls.Add(this.ColorsPictureBox);
       this.Controls.Add(this.chart);
+      this.Controls.Add(this.GrayscalesPictureBox);
       this.Name = "HeatmapView";
       this.Size = new System.Drawing.Size(444, 358);
       ((System.ComponentModel.ISupportInitialize)(this.chart)).EndInit();
       ((System.ComponentModel.ISupportInitialize)(this.ColorsPictureBox)).EndInit();
+      ((System.ComponentModel.ISupportInitialize)(this.GrayscalesPictureBox)).EndInit();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -130,4 +157,6 @@
     private System.Windows.Forms.Label ZeroLabel;
     private System.Windows.Forms.Label OneLabel;
+    private System.Windows.Forms.PictureBox GrayscalesPictureBox;
+    private System.Windows.Forms.CheckBox grayscaledImagesCheckBox;
   }
 }
Index: /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.cs
===================================================================
--- /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.cs	(revision 4700)
+++ /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.cs	(revision 4701)
@@ -39,4 +39,35 @@
   public partial class HeatmapView : ItemView {
 
+    private static Color[] Colors;
+    private static int ColorsCount = 500;
+    private static Color[] GrayscaleColors = new Color[256];
+
+    #region InitializeColors
+    static HeatmapView() {
+      int stepWidth = (255 * 6) / ColorsCount;
+      Color[] colors = new Color[ColorsCount];
+      int currentValue;
+      int currentClass;
+      for (int i = 0; i < ColorsCount; i++) {
+        currentValue = (i * stepWidth) % 255;
+        currentClass = (i * stepWidth) / 255;
+        switch (currentClass) {
+          case 0: { colors[i] = Color.FromArgb(255, currentValue, 0); break; }
+          case 1: { colors[i] = Color.FromArgb(255 - currentValue, 255, 0); break; }
+          case 2: { colors[i] = Color.FromArgb(0, 255, currentValue); break; }
+          case 3: { colors[i] = Color.FromArgb(0, 255 - currentValue, 255); break; }
+          case 4: { colors[i] = Color.FromArgb(currentValue, 0, 255); break; }
+          case 5: { colors[i] = Color.FromArgb(255, 0, 255 - currentValue); break; }
+        }
+      }
+      int n = (int)(ColorsCount * 0.7);
+      Colors = new Color[n];
+      for (int i = 0; i < n; i++)
+        Colors[i] = colors[i];
+      for (int i = 0; i < 256; i++)
+        GrayscaleColors[i] = Color.FromArgb(i, i, i);
+    }
+    #endregion
+
     public new DoubleMatrix Content {
       get { return (DoubleMatrix)base.Content; }
@@ -47,53 +78,55 @@
       InitializeComponent();
       chart.CustomizeAllChartAreas();
-      /*
-      Series s = new Series();
-      DataPoint p = new DataPoint(0.4, 0.2);
-      p.Color = Color.Red;
-      p.MarkerStyle = MarkerStyle.None;
-      p.MarkerSize = 10;
-      s.Points.Add(p);
-      DataPoint p2 = new DataPoint(0.6, 0.5);
-      p2.Color = Color.Red;
-      p2.MarkerStyle = MarkerStyle.None;
-      p2.MarkerSize = 40;
-      s.Points.Add(p2);
-      DataPoint p3 = new DataPoint(0.8, 0.2);
-      p3.Color = Color.Red;
-      p3.MarkerStyle = MarkerStyle.None;
-      p3.MarkerSize = 40;
-      s.Points.Add(p3);
-      DataPoint p4 = new DataPoint(0.7, 0.3);
-      p4.Color = Color.Red;
-      p4.MarkerStyle = MarkerStyle.None;
-      p4.MarkerSize = 40;
-      s.Points.Add(p4);
-      s.ChartType = SeriesChartType.Area;
-      s.XValueType = ChartValueType.String;
-      s.YValueType = ChartValueType.Double;
-      s.YAxisType = AxisType.Primary;
-      chart.Series.Add(s);
-      chart.Update();*/
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        chart.Series.Clear();
+      } else {
+        UpdateChart();
+      }
+    }
+
+    private void UpdateChart() {
+      chart.Series.Clear();
+      Series series = new Series();
+      series.ChartType = SeriesChartType.Point;
+      series.XValueType = ChartValueType.Int32;
+      series.YValueType = ChartValueType.Int32;
+      series.YAxisType = AxisType.Primary;
+      for (int i = 0; i < Content.Rows; i++)
+        for (int j = 0; j < Content.Columns; j++)
+          series.Points.Add(CreateDataPoint(i, j, Content[i, j]));
+      chart.ChartAreas[0].AxisY.Minimum = 0;
+      chart.ChartAreas[0].AxisY.Maximum = Content.Rows;
+      chart.Series.Add(series);
+      chart.Legends.Clear();
+    }
+
+    private DataPoint CreateDataPoint(int index1, int index2, double value) {
+      bool grayScaleModus = grayscaledImagesCheckBox.Checked;
+      int n = grayScaleModus ? GrayscaleColors.Length : Colors.Length;
+      int colorIndex = (int)((n - 1) * value);
+      if (colorIndex >= n) colorIndex = n - 1;
+      if (colorIndex < 0) colorIndex = 0;
+      // invert so that red is 1, blue 0 / black is 1, white 0
+      colorIndex = n - colorIndex - 1;
+      Color color = grayScaleModus ? GrayscaleColors[colorIndex] : Colors[colorIndex];
+
+      DataPoint p = new DataPoint(index1, index2);
+      p.Color = color;
+      p.MarkerStyle = MarkerStyle.Square;
+      p.ToolTip = string.Format("Solution {0} vs. solution {1}: {2}",
+                                index1, index2, value);
+      return p;
     }
 
     #region Chart Events
-    protected virtual void chart_MouseDown(object sender, MouseEventArgs e) {
-      HitTestResult result = chart.HitTest(e.X, e.Y);
-      //
-    }
 
-    protected virtual void chart_MouseMove(object sender, MouseEventArgs e) {
-      HitTestResult result = chart.HitTest(e.X, e.Y);
-      if (result.ChartElementType == ChartElementType.LegendItem)
-        this.Cursor = Cursors.Hand;
-      else
-        this.Cursor = Cursors.Default;
-    }
-
-    protected virtual void chart_CustomizeLegend(object sender, CustomizeLegendEventArgs e) {
-      foreach (LegendItem legendItem in e.LegendItems) {
-        var series = chart.Series[legendItem.SeriesName];
-        //
-      }
+    private void grayscaledImagesCheckBox_CheckedChanged(object sender, EventArgs e) {
+      GrayscalesPictureBox.Visible = grayscaledImagesCheckBox.Checked;
+      ColorsPictureBox.Visible = !grayscaledImagesCheckBox.Checked;
+      UpdateChart();
     }
 
